#!/usr/bin/perl

# :	-f -m -a (,, )
#		-v (  )
#		-n (  )
#		-c=cp1251, ...   ,   iconv ( )

print("Usage: n2rus [OPTION...] Number1 [Number2 ...]
Output russian string of given number(s). v1.02\n
 Input/Output format specification:
  -f | -m | -a \t\t famale, male, average rod
  -v \t\t\t Print input number(s)
  -n \t\t\t No print symbol <CR>\n
Options and number(s) may be random positioned. Max number is 999 999 999 999
For bug reporting instructions, please to Aleksander N.Gorohovski:
<angel\@feht.dgtu.donetsk.ua>.
"),exit if !@ARGV;

@Un0=('',"","","","","","","","","","",
	"","","","","","",
	"","","");

@Uf=('',"","");	# 
@Um=('',"","");	# 
@Ua=('',"","");	# 

@Dcml=('','',"","","","","","","","");
@Cent=('',"","","","","","","","","");

@m1=("",'',"a","","","","","","","");
@m2=('',"a","","","");
@Pr=('',"","","");

#   
$fma='m';
$n="\n";
#   
for(@ARGV){
    push @Ns,$_+0 if /^\d+$/;	#   
    $fma=$1 if /^-(f|m|a)$/;	# 
    $v=1 if /^-v$/;
    $n='' if /^-n$/;
    $cd=$1 if /^-c=(\w+)$/;	#  
}

for my $sA (@Ns){

    print"$sA=" if $v;
    print("$n"),next if ! $sA;
    print(">999999999999$n"),next if length($sA)>12;
    $Un0[$_]=$Um[$_] for(1,2);
    my @Ml=@m1;

    my @s;
    while(length($sA)>0){

	my $i=int length($sA)/3;
	if($i<2){
	    $Un0[$_]=$Uf[$_] for(1,2);
	    $Ml[$_]=$m2[$_] for(0..9);
	}
	if(length($sA)==1){$Un0[$_]=${"U$fma"}[$_] for(1,2)}

	if(length($sA)%3==0){			# 100...-999...
	    $sA=~s/(\d)(\d*)/$2/;
	    push @s,$Cent[$1] if $1;
	    next
	}
	if(length($sA)%3==2){			# 10...-99...
	    if($sA=~/^1/){				# 10...-19...
    		$sA=~s/(\d\d)(\d*)/$2/;
    		push @s,$Un0[$1] if $1;
    		push @s,$Pr[$i].$Ml[0];
	    }else{					# 20...-99...
    		$sA=~s/(\d)(\d*)/$2/;
    		push @s,$Dcml[$1] if $1;
	    }
	    next
	}
	push(@s,$Un0[$sA]),last if $sA=~/^.$/;

	if(length($sA)%3==1){			# 1...-9...
	    $sA=~s/(\d)(\d*)/$2/;
	    push @s,$Un0[$1] if $1;
	    push @s,$Pr[$i].$Ml[$1] unless $s[-1]=~/^/;
	}
    }
    print join(' ',@s),$n;
}
exit;